Attribute VB_Name = "GeneralModule"
Public Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Public AllKeys()        As String
Public ArmadilloKeys()  As String
Public ASProtectKeys()  As String
Public AS_EnumKeys()    As String
Public ObsidiumKeys()   As String
Public PCGuardKeys()    As String
Public XProtectorKeys() As String

Public Enum WhatToDo
    LineChange
    NoLineChange
End Enum

Public Enum Packers
    ACProtect
    Armadillo
    ASProtect
    Obsidium
    PCGuard
    SVK
    XProtector
End Enum

Dim lPid        As Long
Dim lHnd        As Long
Dim lRet        As Long

Public Const SYNCHRONIZE = &H100000
Public Const INFINITE = &HFFFF

Global SystemDir
Global WindowsDir
Global TempDir

Global ASProtect_FLAG   As Boolean

Public Sub ShowProgress(ByVal TheText As String, ByVal Action As WhatToDo)
If Action = LineChange Then
    Main.Text1.Text = Main.Text1.Text & TheText & vbCrLf
ElseIf Action = NoLineChange Then
    Main.Text1.Text = Main.Text1.Text & TheText
End If
Main.Text1.SelStart = Len(Main.Text1.Text)
End Sub
Public Sub ExtractValidKeys(ByVal hKey As RegistryPaths, ByVal Packer As Packers)
Dim TheValue As String

For i = 1 To UBound(AllKeys)
    DoEvents
    
    If Packer = Armadillo Then
        If hKey = HKEY_CLASSES_ROOT Then
            EnumValues HKEY_CLASSES_ROOT, "CLSID\" & AllKeys(i)
        ElseIf hKey = HKEY_CURRENT_USER Then
            EnumValues HKEY_CLASSES_ROOT, "SOFTWARE\Classes\" & AllKeys(i)
        End If
    
    ElseIf Packer = ASProtect Then
        TheValue = Trim(ReadValue(HKEY_CLASSES_ROOT, "CLSID\" & AllKeys(i), ""))
        If TheValue = "" Then
            TheValue = Trim(ReadValue(HKEY_CLASSES_ROOT, "CLSID\" & AllKeys(i) & "\TypeLib", ""))
            If TheValue <> "" Then
                ASProtect_FLAG = True
                Erase AS_EnumKeys()
                ReDim AS_EnumKeys(0) As String
                EnumKeys HKEY_CLASSES_ROOT, "TypeLib\" & TheValue
                
                If UBound(AS_EnumKeys) = 0 Then
                    ReDim Preserve ASProtectKeys(UBound(ASProtectKeys) + 2) As String
                    ASProtectKeys(UBound(ASProtectKeys) - 1) = "CLSID\" & AllKeys(i)
                    ASProtectKeys(UBound(ASProtectKeys)) = "TypeLib\" & TheValue
                End If
                
                ASProtect_FLAG = False
                Erase AS_EnumKeys()
            End If
        End If
    
    ElseIf Packer = Obsidium Then
        If hKey = HKEY_CLASSES_ROOT Then
            TheValue = Trim(ReadValue(HKEY_CLASSES_ROOT, "CLSID\" & AllKeys(i), ""))
            If TheValue = "Picture (Metafile)" Then
                TheValue = Trim(ReadValue(HKEY_CLASSES_ROOT, "CLSID\" & AllKeys(i), "AppID"))
                If TheValue <> "" Then
                    ReDim Preserve ObsidiumKeys(UBound(ObsidiumKeys) + 1) As String
                    ObsidiumKeys(UBound(ObsidiumKeys)) = "CLSID\" & AllKeys(i)
                End If
            End If
        ElseIf hKey = HKEY_CURRENT_USER Then
            ReDim Preserve ObsidiumKeys(UBound(ObsidiumKeys) + 1) As String
            ObsidiumKeys(UBound(ObsidiumKeys)) = "SOFTWARE\Obsidium\" & AllKeys(i)
        End If
    
    ElseIf Packer = PCGuard Then
        TheValue = Trim(ReadValue(hKey, AllKeys(i), Chr$(32)))
        If TheValue <> "" Then
            ReDim Preserve PCGuardKeys(UBound(PCGuardKeys) + 1) As String
            PCGuardKeys(UBound(PCGuardKeys)) = AllKeys(i)
        End If
        
    ElseIf Packer = XProtector Then
        If (Left$(AllKeys(i), 1) <> "{") And (Len(AllKeys(i)) = 32) Then
            ReDim Preserve XProtectorKeys(UBound(XProtectorKeys) + 1) As String
            XProtectorKeys(UBound(XProtectorKeys)) = "CLSID\" & AllKeys(i)
        End If
        
    End If
Next i
End Sub
Public Sub GetDirectories()
Set FSO = CreateObject("Scripting.FileSystemObject")
Set WindowsDir = FSO.GetSpecialFolder(0)
Set SystemDir = FSO.GetSpecialFolder(1)
Set TempDir = FSO.GetSpecialFolder(2)

If Right$(WindowsDir, 1) <> "\" Then WindowsDir = WindowsDir & "\"
If Right$(SystemDir, 1) <> "\" Then SystemDir = SystemDir & "\"
If Right$(TempDir, 1) <> "\" Then TempDir = TempDir & "\"
End Sub
Public Function ExistFile(FilePath As String) As Boolean
Dim FSO
Set FSO = CreateObject("Scripting.FileSystemObject")
ExistFile = FSO.FileExists(FilePath)
End Function
Public Function GetAccessTime(ByVal TheFile As String) As String
Dim FSO, fs
Set FSO = CreateObject("Scripting.FileSystemObject")
Set fs = FSO.GetFile(TheFile)
GetAccessTime = fs.DateLastAccessed
End Function
