Attribute VB_Name = "RemoveModule"
Public Sub Scan_ACProtect()
On Error Resume Next

Dim TheFiles As String
Dim Lister As ListItem

ShowProgress "Searching For ACProtect Files...", NoLineChange
TheFiles = Dir$("C:\*.*", vbHidden)
Do Until Len(TheFiles) = 0
    DoEvents
    If (Len(TheFiles) = 10) And (FileLen("C:\" & TheFiles) = 10) Then
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 1
        Lister.Text = "ACProtect"
        Lister.SubItems(1) = "File"
        Lister.SubItems(2) = "C:\" & TheFiles
    End If
    TheFiles = Dir
Loop
ShowProgress "OK", LineChange
ShowProgress "ACProtect Scan Finished...", LineChange
End Sub
Public Sub Remove_ACProtect()
On Error Resume Next

For i = 1 To Main.ListView1.ListItems.Count
    DoEvents
    If Main.ListView1.ListItems(i).Text = "ACProtect" Then
        ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(2) & " ...", NoLineChange
        SetAttr Main.ListView1.ListItems(i).SubItems(2), vbNormal
        Kill Main.ListView1.ListItems(i).SubItems(2)
        Main.ListView1.ListItems(i).Text = "DELETED"
        ShowProgress "OK", LineChange
    End If
Next i
ShowProgress "ACProtect Removal Finished...", LineChange
End Sub

Public Sub Scan_Armadillo()
On Error Resume Next

Dim Lister As ListItem
Dim TheFiles As String

ShowProgress "Searching For Armadillo Keys In HKEY_CLASSES_ROOT...", NoLineChange
Erase AllKeys()
ReDim AllKeys(0) As String
EnumKeys HKEY_CLASSES_ROOT, "CLSID"
Erase ArmadilloKeys()
ReDim ArmadilloKeys(0) As String
ExtractValidKeys HKEY_CLASSES_ROOT, Armadillo

If UBound(ArmadilloKeys) > 0 Then
    For i = 1 To UBound(ArmadilloKeys)
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 2
        Lister.Text = "Armadillo"
        Lister.SubItems(1) = "Reg"
        Lister.SubItems(2) = "HKEY_CLASSES_ROOT"
        Lister.SubItems(3) = ArmadilloKeys(i)
    Next i
End If
ShowProgress "OK", LineChange

ShowProgress "Searching For Armadillo Keys In HKEY_CURRENT_USER...", NoLineChange
Erase AllKeys()
ReDim AllKeys(0) As String
EnumKeys HKEY_CURRENT_USER, "SOFTWARE\Classes"
Erase ArmadilloKeys()
ReDim ArmadilloKeys(0) As String
ExtractValidKeys HKEY_CURRENT_USER, Armadillo
If UBound(ArmadilloKeys) > 0 Then
    For i = 1 To UBound(ArmadilloKeys)
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 2
        Lister.Text = "Armadillo"
        Lister.SubItems(1) = "Reg"
        Lister.SubItems(2) = "HKEY_CURRENT_USER"
        Lister.SubItems(3) = ArmadilloKeys(i)
    Next i
End If


Erase AllKeys()
Erase ArmadilloKeys()
ShowProgress "OK", LineChange

ShowProgress "Searching For Armadillo Files...", NoLineChange
TheFiles = Dir$(TempDir & "*.tmp")
Do Until Len(TheFiles) = 0
    DoEvents
    If (Left$(TheFiles, 1) <> "~") And (Len(TheFiles) = 12) Then
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 2
        Lister.Text = "Armadillo"
        Lister.SubItems(1) = "File"
        Lister.SubItems(2) = TempDir
        Lister.SubItems(3) = TheFiles
    End If
    TheFiles = Dir
Loop
ShowProgress "OK", LineChange
ShowProgress "Armadillo Scan Finished...", LineChange
End Sub
Public Sub Remove_Armadillo()
On Error Resume Next

ShowProgress "Deleting HKEY_CURRENT_USER\SOFTWARE\The Silicon Realms Toolworks\Armadillo ...", NoLineChange
DeleteKey HKEY_CURRENT_USER, "SOFTWARE\The Silicon Realms Toolworks\Armadillo"
ShowProgress "OK", LineChange

ShowProgress "Deleting HKEY_LOCAL_MACHINE\SOFTWARE\The Silicon Realms Toolworks\Armadillo ...", NoLineChange
DeleteKey HKEY_LOCAL_MACHINE, "SOFTWARE\The Silicon Realms Toolworks\Armadillo"
ShowProgress "OK", LineChange

ShowProgress "Deleting HKEY_LOCAL_MACHINE\SOFTWARE\Licenses ...", NoLineChange
DeleteKey HKEY_LOCAL_MACHINE, "SOFTWARE\Licenses"
ShowProgress "OK", LineChange

For i = 1 To Main.ListView1.ListItems.Count
    DoEvents
    If Main.ListView1.ListItems(i).Text = "Armadillo" Then
        If Main.ListView1.ListItems(i).SubItems(1) = "Reg" Then
            Erase AllKeys()
            ReDim AllKeys(0) As String
            If Main.ListView1.ListItems(i).SubItems(2) = "HKEY_CLASSES_ROOT" Then
                EnumAllRegKeys HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3)
                
                For j = 1 To UBound(AllKeys)
                    DoEvents
                    ShowProgress "Deleting " & AllKeys(j) & " ...", NoLineChange
                    DeleteKey HKEY_CLASSES_ROOT, AllKeys(j)
                    ShowProgress "OK", LineChange
                Next j
                
                For j = 1 To UBound(AllKeys)
                    DoEvents
                    DeleteKey HKEY_CLASSES_ROOT, AllKeys(j)
                Next j
                
                ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3)
                ShowProgress "OK", LineChange
            ElseIf Main.ListView1.ListItems(i).SubItems(2) = "HKEY_CURRENT_USER" Then
                EnumAllRegKeys HKEY_CURRENT_USER, Main.ListView1.ListItems(i).SubItems(3)
                
                For j = 1 To UBound(AllKeys)
                    DoEvents
                    ShowProgress "Deleting " & AllKeys(j) & " ...", NoLineChange
                    DeleteKey HKEY_CURRENT_USER, AllKeys(j)
                    ShowProgress "OK", LineChange
                Next j
                
                For j = 1 To UBound(AllKeys)
                    DoEvents
                    DeleteKey HKEY_CURRENT_USER, AllKeys(j)
                Next j
                
                ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
                DeleteKey HKEY_CURRENT_USER, Main.ListView1.ListItems(i).SubItems(3)
                ShowProgress "OK", LineChange
            End If
        ElseIf Main.ListView1.ListItems(i).SubItems(1) = "File" Then
            ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
            SetAttr Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3), vbNormal
            Kill Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3)
            ShowProgress "OK", LineChange
        End If
        Main.ListView1.ListItems(i).Text = "DELETED"
    End If
Next i

ShowProgress "Armadillo Removal Finished...", LineChange
End Sub

Public Sub Scan_ASProtect()
On Error Resume Next

Dim Lister As ListItem

ShowProgress "Searching For ASPack Keys...", NoLineChange
Erase AllKeys()
ReDim AllKeys(0) As String
EnumKeys HKEY_CLASSES_ROOT, "CLSID"
Erase ASProtectKeys()
ReDim ASProtectKeys(0) As String
ExtractValidKeys HKEY_CLASSES_ROOT, ASProtect

If UBound(ASProtectKeys) > 0 Then
    For i = 1 To UBound(ASProtectKeys)
        DoEvents
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 3
        Lister.Text = "ASProtect"
        Lister.SubItems(1) = "Reg"
        Lister.SubItems(2) = "HKEY_CLASSES_ROOT"
        Lister.SubItems(3) = ASProtectKeys(i)
    Next i
    ASProtect_FLAG = False
End If

Erase ASProtectKeys()
Erase AllKeys()

ShowProgress "OK", LineChange
ShowProgress "ASProtect Scan Finished...", LineChange
End Sub
Public Sub Remove_ASProtect()
On Error Resume Next

Erase AllKeys()
ReDim AllKeys(0) As String
EnumAllRegKeys HKEY_CURRENT_USER, "SOFTWARE\ASProtect"

For i = 1 To UBound(AllKeys)
    DoEvents
    ShowProgress "Deleting " & AllKeys(i) & " ...", NoLineChange
    DeleteKey HKEY_CURRENT_USER, AllKeys(i)
    ShowProgress "OK", LineChange
Next i
Erase AllKeys()

For i = 1 To Main.ListView1.ListItems.Count
    DoEvents
    If Main.ListView1.ListItems(i).Text = "ASProtect" Then
        Erase AllKeys()
        ReDim AllKeys(0) As String
        EnumAllRegKeys HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3)
        
        For j = 1 To UBound(AllKeys)
            DoEvents
            ShowProgress "Deleting " & AllKeys(j) & " ...", NoLineChange
            DeleteKey HKEY_CLASSES_ROOT, AllKeys(j)
            ShowProgress "OK", LineChange
        Next j
        
        For j = 1 To UBound(AllKeys)
            DoEvents
            DeleteKey HKEY_CLASSES_ROOT, AllKeys(j)
        Next j
        
        ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
        DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3)
        ShowProgress "OK", LineChange
        
        Main.ListView1.ListItems(i).Text = "DELETED"
    End If
Next i

ShowProgress "ASProtect Removal Finished...", LineChange
End Sub
Public Sub Scan_Obsidium()
On Error Resume Next

Dim TheFiles As String
Dim TempPath As String
Dim Lister As ListItem

ShowProgress "Searching For Obsidium Keys In HKEY_CLASSES_ROOT...", NoLineChange
Erase AllKeys()
ReDim AllKeys(0) As String
EnumKeys HKEY_CLASSES_ROOT, "CLSID"
Erase ObsidiumKeys()
ReDim ObsidiumKeys(0) As String
ExtractValidKeys HKEY_CLASSES_ROOT, Obsidium

If UBound(ObsidiumKeys) > 0 Then
    For i = 1 To UBound(ObsidiumKeys)
        DoEvents
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 4
        Lister.Text = "Obsidium"
        Lister.SubItems(1) = "Reg"
        Lister.SubItems(2) = "HKEY_CLASSES_ROOT"
        Lister.SubItems(3) = ObsidiumKeys(i)
    Next i
End If
ShowProgress "OK", LineChange

ShowProgress "Searching For Obsidium Keys In HKEY_CURRENT_USER...", NoLineChange
Erase AllKeys()
ReDim AllKeys(0) As String
EnumKeys HKEY_CURRENT_USER, "SOFTWARE\Obsidium"
Erase ObsidiumKeys()
ReDim ObsidiumKeys(0) As String
ExtractValidKeys HKEY_CURRENT_USER, Obsidium

If UBound(ObsidiumKeys) > 0 Then
    For i = 1 To UBound(ObsidiumKeys)
        DoEvents
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 4
        Lister.Text = "Obsidium"
        Lister.SubItems(1) = "Reg"
        Lister.SubItems(2) = "HKEY_CURRENT_USER"
        Lister.SubItems(3) = ObsidiumKeys(i)
    Next i
End If

Erase AllKeys()
Erase ObsidiumKeys()

ShowProgress "OK", LineChange

ShowProgress "Searching For Obsidium Files...", NoLineChange
TempPath = Trim(ReadValue(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", "AppData"))
If Right$(TempPath, 1) <> "\" Then TempPath = TempPath & "\"
TempPath = TempPath & "Obsidium\"

TheFiles = Dir$(TempPath & "*.*")
Do Until Len(TheFiles) = 0
    DoEvents
    Set Lister = Main.ListView1.ListItems.Add()
    Lister.SmallIcon = 4
    Lister.Text = "Obsidium"
    Lister.SubItems(1) = "File"
    Lister.SubItems(2) = TempPath
    Lister.SubItems(3) = TheFiles
    
    TheFiles = Dir
Loop
ShowProgress "OK", LineChange
ShowProgress "Obsidium Scan Finished...", LineChange
End Sub

Public Sub Remove_Obsidium()
On Error Resume Next

For i = 1 To Main.ListView1.ListItems.Count
    DoEvents
    If Main.ListView1.ListItems(i).Text = "Obsidium" Then
        If Main.ListView1.ListItems(i).SubItems(1) = "Reg" Then
            If Main.ListView1.ListItems(i).SubItems(2) = "HKEY_CLASSES_ROOT" Then
                ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
                
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\ProgID"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\MiscStatus"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\InProcServer32"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\DataFormats\DefaultFile"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\DataFormats\GetSet\0"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\DataFormats\GetSet"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\DataFormats"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\Conversion\Readable\Main"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\Conversion\Readable"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\Conversion"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\AuxUserType\2"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3) & "\AuxUserType"
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3)
                
                ShowProgress "OK", LineChange
            ElseIf Main.ListView1.ListItems(i).SubItems(2) = "HKEY_CURRENT_USER" Then
                ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
                DeleteKey HKEY_CURRENT_USER, Main.ListView1.ListItems(i).SubItems(3)
                ShowProgress "OK", LineChange
            End If
        ElseIf Main.ListView1.ListItems(i).SubItems(1) = "File" Then
            ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
            SetAttr Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3), vbNormal
            Kill Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3)
            ShowProgress "OK", LineChange
        End If
        
        Main.ListView1.ListItems(i).Text = "DELETED"
    End If
Next i

ShowProgress "Obsidium Removal Finished...", LineChange
End Sub

Public Sub Scan_PCGuard()
On Error Resume Next

Dim Lister As ListItem
Dim TheFiles As String

ShowProgress "Searching For PCGuard Keys In HKEY_CLASSES_ROOT...", NoLineChange
Erase AllKeys()
ReDim AllKeys(0) As String
EnumAllRegKeys HKEY_CLASSES_ROOT, ""
Erase PCGuardKeys()
ReDim PCGuardKeys(0) As String
ExtractValidKeys HKEY_CLASSES_ROOT, PCGuard

If UBound(PCGuardKeys) > 0 Then
    For i = 1 To UBound(PCGuardKeys)
        DoEvents
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 5
        Lister.Text = "PCGuard"
        Lister.SubItems(1) = "Reg"
        Lister.SubItems(2) = "HKEY_CLASSES_ROOT"
        Lister.SubItems(3) = PCGuardKeys(i)
    Next i
End If
ShowProgress "OK", LineChange

ShowProgress "Searching For PCGuard Keys In HKEY_CURRENT_USER...", NoLineChange
Erase AllKeys()
ReDim AllKeys(0) As String
EnumAllRegKeys HKEY_CURRENT_USER, ""
Erase PCGuardKeys()
ReDim PCGuardKeys(0) As String
ExtractValidKeys HKEY_CURRENT_USER, PCGuard

If UBound(PCGuardKeys) > 0 Then
    For i = 1 To UBound(PCGuardKeys)
        DoEvents
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 5
        Lister.Text = "PCGuard"
        Lister.SubItems(1) = "Reg"
        Lister.SubItems(2) = "HKEY_CURRENT_USER"
        Lister.SubItems(3) = PCGuardKeys(i)
    Next i
End If
ShowProgress "OK", LineChange

ShowProgress "Searching For PCGuard Keys In HKEY_LOCAL_MACHINE...", NoLineChange
Erase AllKeys()
ReDim AllKeys(0) As String
EnumAllRegKeys HKEY_LOCAL_MACHINE, ""
Erase PCGuardKeys()
ReDim PCGuardKeys(0) As String
ExtractValidKeys HKEY_LOCAL_MACHINE, PCGuard

If UBound(PCGuardKeys) > 0 Then
    For i = 1 To UBound(PCGuardKeys)
        DoEvents
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 5
        Lister.Text = "PCGuard"
        Lister.SubItems(1) = "Reg"
        Lister.SubItems(2) = "HKEY_LOCAL_MACHINE"
        Lister.SubItems(3) = PCGuardKeys(i)
    Next i
End If
ShowProgress "OK", LineChange

Erase AllKeys()
Erase PCGuardKeys()

ShowProgress "Searching For PCGuard Files...", NoLineChange
TheFiles = Dir(Left$(WindowsDir, 3) & "*.*", vbHidden + vbSystem)
Do Until Len(TheFiles) = 0
    DoEvents
    If Left$(TheFiles, 8) = "PCGWIN32" Then
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 5
        Lister.Text = "PCGuard"
        Lister.SubItems(1) = "File"
        Lister.SubItems(2) = Left$(WindowsDir, 3)
        Lister.SubItems(3) = TheFiles
    End If
    TheFiles = Dir
Loop

TheFiles = Dir(WindowsDir & "*.*", vbHidden + vbSystem)
Do Until Len(TheFiles) = 0
    DoEvents
    If Left$(TheFiles, 8) = "PCGWIN32" Then
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 5
        Lister.Text = "PCGuard"
        Lister.SubItems(1) = "File"
        Lister.SubItems(2) = WindowsDir
        Lister.SubItems(3) = TheFiles
    End If
    TheFiles = Dir
Loop

TheFiles = Dir(SystemDir & "*.*", vbHidden + vbSystem)
Do Until Len(TheFiles) = 0
    DoEvents
    If Left$(TheFiles, 8) = "PCGWIN32" Then
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 5
        Lister.Text = "PCGuard"
        Lister.SubItems(1) = "File"
        Lister.SubItems(2) = System
        Lister.SubItems(3) = TheFiles
    End If
    TheFiles = Dir
Loop

ShowProgress "OK", LineChange
ShowProgress "PCGuard Scan Finished...", LineChange
End Sub
Public Sub Remove_PCGuard()
On Error Resume Next

For i = 1 To Main.ListView1.ListItems.Count
    DoEvents
    If Main.ListView1.ListItems(i).Text = "PCGuard" Then
        If Main.ListView1.ListItems(i).SubItems(1) = "Reg" Then
            ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
            If Main.ListView1.ListItems(i).SubItems(2) = "HKEY_CLASSES_ROOT" Then
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3)
            ElseIf Main.ListView1.ListItems(i).SubItems(2) = "HKEY_CURRENT_USER" Then
                DeleteKey HKEY_CURRENT_USER, Main.ListView1.ListItems(i).SubItems(3)
            ElseIf Main.ListView1.ListItems(i).SubItems(2) = "HKEY_LOCAL_MACHINE" Then
                DeleteKey HKEY_LOCAL_MACHINE, Main.ListView1.ListItems(i).SubItems(3)
            End If
            ShowProgress "OK", LineChange
        ElseIf Main.ListView1.ListItems(i).SubItems(1) = "File" Then
            ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
            SetAttr Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3), vbNormal
            Kill Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3)
            ShowProgress "OK", LineChange
        End If
        
        Main.ListView1.ListItems(i).Text = "DELETED"
    End If
Next i

ShowProgress "PCGuard Removal Finished...", LineChange
End Sub

Public Sub Scan_SVK()
On Error Resume Next

Dim Lister As ListItem

ShowProgress "Searching For SVK Files...", NoLineChange
If ExistFile(SystemDir & "is.dll") Then
    Set Lister = Main.ListView1.ListItems.Add()
    Lister.SmallIcon = 6
    Lister.Text = "SVK"
    Lister.SubItems(1) = "File"
    Lister.SubItems(2) = SystemDir
    Lister.SubItems(3) = "is.dll"
End If

If ExistFile(SystemDir & "aa.dll") Then
    Set Lister = Main.ListView1.ListItems.Add()
    Lister.SmallIcon = 6
    Lister.Text = "SVK"
    Lister.SubItems(1) = "File"
    Lister.SubItems(2) = SystemDir
    Lister.SubItems(3) = "aa.dll"
End If

ShowProgress "OK", LineChange
ShowProgress "SVK Scan Finished...", LineChange
End Sub
Public Sub Remove_SVK()
On Error Resume Next

For i = 1 To Main.ListView1.ListItems.Count
    DoEvents
    If Main.ListView1.ListItems(i).Text = "SVK" Then
        ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
        SetAttr Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3), vbNormal
        Kill Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3)
        ShowProgress "OK", LineChange
        
        Main.ListView1.ListItems(i).Text = "DELETED"
    End If
Next i
ShowProgress "SVK Removal Finished...", LineChange
End Sub

Public Sub Scan_XProtector()
On Error Resume Next

Dim Lister As ListItem

ShowProgress "Searching For XProtector Keys...", NoLineChange
Erase AllKeys()
ReDim AllKeys(0) As String
EnumKeys HKEY_CLASSES_ROOT, "CLSID"
Erase XProtectorKeys()
ReDim XProtectorKeys(0) As String
ExtractValidKeys HKEY_CLASSES_ROOT, XProtector

If UBound(XProtectorKeys) > 0 Then
    For i = 1 To UBound(XProtectorKeys)
        DoEvents
        Set Lister = Main.ListView1.ListItems.Add()
        Lister.SmallIcon = 7
        Lister.Text = "XProtector"
        Lister.SubItems(1) = "Reg"
        Lister.SubItems(2) = "HKEY_CLASSES_ROOT"
        Lister.SubItems(3) = XProtectorKeys(i)
    Next i
End If

ShowProgress "OK", LineChange
ShowProgress "XProtector Scan Finished...", LineChange
End Sub
Public Sub Remove_XProtector()
On Error Resume Next

Dim TheFiles As String

Dim OldDate     As String
Dim NewDate     As String
Dim TheDate     As String

Dim OldHours    As Integer
Dim OldMinutes  As Integer
Dim NewHours    As Integer
Dim NewMinutes  As Integer
Dim ThePos      As Integer

MsgBox "To Continue, You Need To Run The Specific Application For Which You Wish To" & vbCrLf & _
        "Remove The Evaluation Information Stored In Your Computer.Select That Program" & vbCrLf & _
        "From The Dialog Box That Will Appear." & vbCrLf & _
        "REMEMBER : Close The Protected Application IMMEDIATELY After It Has Been Loaded...", vbInformation, "EVA Cleaner - XProtector"
        
Main.CommonDialog1.DialogTitle = "Select XProtector Protected Application..."
Main.CommonDialog1.Filter = "EXE Files (*.exe)|*.exe"
Main.CommonDialog1.Flags = &H4
Main.CommonDialog1.ShowOpen

If Main.CommonDialog1.FileName = "" Then
    ShowProgress "Process Aborted By User...", LineChange
    Exit Sub
End If

OldDate = Date
OldHours = Left$(Time, 2)
OldMinutes = Mid$(Time, 4, 2)

lPid = Shell(Main.CommonDialog1.FileName, vbNormalFocus)

If lPid <> 0 Then
    lHnd = OpenProcess(SYNCHRONIZE, 0, lPid)
    If lHnd <> 0 Then
        lRet = WaitForSingleObject(lHnd, INFINITE)
        CloseHandle (lHnd)
    End If
End If

TheFiles = Dir$(SystemDir & "*.*")
Do Until Len(TheFiles) = 0
    DoEvents
    If Len(TheFiles) = 12 Then
        TheDate = GetAccessTime(SystemDir & TheFiles)
        ThePos = InStr(1, TheDate, Chr$(32))
        If ThePos > 0 Then
            NewDate = Left$(TheDate, ThePos - 1)
            NewHours = Mid$(TheDate, ThePos + 1, 2)
            NewMinutes = Mid$(TheDate, ThePos + 4, 2)
        Else
            NewDate = ""
            NewHours = 0
            NewMinutes = 0
        End If
        
        If OldDate = NewDate Then
            If (NewHours = OldHours) And (NewMinutes = OldMinutes) Then
                If UCase$(Right$(TheFiles, 4)) <> ".DLL" And _
                   UCase$(Right$(TheFiles, 4)) <> ".EXE" And _
                   UCase$(Right$(TheFiles, 4)) <> ".OCX" And _
                   UCase$(Right$(TheFiles, 4)) <> ".SYS" And _
                   UCase$(Right$(TheFiles, 4)) <> ".COM" And _
                   UCase$(Right$(TheFiles, 4)) <> ".VXD" Then
                    
                    ShowProgress "Deleting " & TheFiles & " ...", NoLineChange
                    SetAttr SystemDir & TheFiles, vbNormal
                    Kill SystemDir & TheFiles
                    ShowProgress "OK", LineChange
                End If
            End If
        End If
    End If
    TheFiles = Dir
Loop

For i = 1 To Main.ListView1.ListItems.Count
    DoEvents
    If Main.ListView1.ListItems(i).Text = "XProtector" Then
        ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
        DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3)
        ShowProgress "OK", LineChange
        
        Main.ListView1.ListItems(i).Text = "DELETED"
    End If
Next i

ShowProgress "XProtector Removal Finished...", LineChange
    
End Sub
Public Sub Remove_Selected()
On Error Resume Next

For i = 1 To Main.ListView1.ListItems.Count
    DoEvents
    If Main.ListView1.ListItems(i).Checked = True Then
        If Main.ListView1.ListItems(i).SubItems(1) = "Reg" Then
            Erase AllKeys()
            ReDim AllKeys(0) As String
            If Main.ListView1.ListItems(i).SubItems(2) = "HKEY_CLASSES_ROOT" Then
                EnumAllRegKeys HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3)
                
                For j = 1 To UBound(AllKeys)
                    DoEvents
                    ShowProgress "Deleting " & AllKeys(j) & " ...", NoLineChange
                    DeleteKey HKEY_CLASSES_ROOT, AllKeys(j)
                    ShowProgress "OK", LineChange
                Next j
                
                For j = 1 To UBound(AllKeys)
                    DoEvents
                    DeleteKey HKEY_CLASSES_ROOT, AllKeys(j)
                Next j
                
                DeleteKey HKEY_CLASSES_ROOT, Main.ListView1.ListItems(i).SubItems(3)
            ElseIf Main.ListView1.ListItems(i).SubItems(2) = "HKEY_CURRENT_USER" Then
                EnumAllRegKeys HKEY_CURRENT_USER, Main.ListView1.ListItems(i).SubItems(3)
                
                For j = 1 To UBound(AllKeys)
                    DoEvents
                    ShowProgress "Deleting " & AllKeys(j) & " ...", NoLineChange
                    DeleteKey HKEY_CURRENT_USER, AllKeys(j)
                    ShowProgress "OK", LineChange
                Next j
                
                For j = 1 To UBound(AllKeys)
                    DoEvents
                    DeleteKey HKEY_CURRENT_USER, AllKeys(j)
                Next j
                
                DeleteKey HKEY_CURRENT_USER, Main.ListView1.ListItems(i).SubItems(3)
            ElseIf Main.ListView1.ListItems(i).SubItems(2) = "HKEY_LOCAL_MACHINE" Then
                EnumAllRegKeys HKEY_LOCAL_MACHINE, Main.ListView1.ListItems(i).SubItems(3)
                
                For j = 1 To UBound(AllKeys)
                    DoEvents
                    ShowProgress "Deleting " & AllKeys(j) & " ...", NoLineChange
                    DeleteKey HKEY_LOCAL_MACHINE, AllKeys(j)
                    ShowProgress "OK", LineChange
                Next j
                
                For j = 1 To UBound(AllKeys)
                    DoEvents
                    DeleteKey HKEY_LOCAL_MACHINE, AllKeys(j)
                Next j
                
                DeleteKey HKEY_LOCAL_MACHINE, Main.ListView1.ListItems(i).SubItems(3)
            End If
            Erase AllKeys()
        ElseIf Main.ListView1.ListItems(i).SubItems(1) = "File" Then
            ShowProgress "Deleting " & Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3) & " ...", NoLineChange
            SetAttr Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3), vbNormal
            Kill Main.ListView1.ListItems(i).SubItems(2) & Main.ListView1.ListItems(i).SubItems(3)
            ShowProgress "OK", LineChange
        End If
        
        Main.ListView1.ListItems(i).Text = "DELETED"
    End If
Next i
End Sub
